      program gfitm1 ! bernd berg, may 20 2015.
c
c Levenberg-Marquardt fit program for least-square fitting
c                                 with one parameter less.
c
c  ndat:   actual number of data (read from data file).
c
      include '../../libs/fortran/implicit.sta'
      include '../../libs/fortran/constants.par'
      parameter(iuo=6,iud=10)
      include '../../libs/subs/common_fitting.f' ! Defines:
c mdat fortran parameter: maximum number of data.
c x,y,ye arrays of dimension mdat (ndat used): data and error bars.
c
c read data:
      open(iud,form='formatted',status='old')
      read(iud,*) ndat
      write(iuo,'(/," number of data:",i12)') ndat
      if(ndat.gt.mdat) stop "gfit: mdat too small."
      write(iuo,'(/," initial guess for the fit parameters:")')
      do i=1,ndat
        read(iud,*)           x(i),y(i),ye(i)
        write(iuo,'(3g16.7)') x(i),y(i),ye(i)
      end do
      close(iud)
c
      write(iuo,'(/," results for the fit parameters:")')
      call chi2c0n0(ndat,x,y,ye,a(1),ae(1),chi2)
      write(iuo,'("  normalization:",g16.7,"  +/-",g15.7)') a(1),ae(1)
      write(iuo,'("  chi2    of the fit:",g16.7)') chi2
c
c prepare gnuplot plot:
      call fit_gnu(iuo,iud,ndat,ione,x,y,ye,a)
c
      stop
      end

      include '../../libs/fortran/chi2c0n0.f' 
      include '../../libs/fortran/fit_gnu.f'
      include '../../libs/fortran/fla.f'
      include '../../libs/subs/suby_la1su2.f' ! suby.
      include '../../libs/subs/subg_la1su2.f' ! subg.
