      program gfit ! bernd berg, may 20 2015.
c
c Levenberg-Marquardt fit program for least-square fitting
c                                 with one parameter less.
c
c  nfit:   number of fit parameters used.
c  ndat:   actual number of data (read from data file).
c  lpri:   print control parameter.
c
      include '../../libs/fortran/implicit.sta'
      include '../../libs/fortran/constants.par'
      parameter(nfit=3,lpri=.true., iuo=6,iud=10)
      dimension cova(nfit,nfit),amat(nfit,nfit)
      include '../../libs/subs/common_fitting.f' ! Defines:
c mdat fortran parameter: maximum number of data.
c mfit fortran parameter: maximum number of fit parameters.
c x,y,ye arrays of dimension mdat (ndat used): data and error bars.
c a array of dimension mfit (nfit+1 used): fit parameters (initial 
c                  guess for nfit of them read from data file iud).
c
c read data:
      open(iud,form='formatted',status='old')
      read(iud,*) ndat,(a(i),i=1,nfit)
      write(iuo,'(/," number of data:",i12)') ndat
      if(ndat.gt.mdat) stop "gfit: mdat too small."
      write(iuo,'(/," initial guess for the fit parameters:")')
      do i=1,nfit
        write(iuo,'(" i,a(i):",i6,g18.7)') i,a(i)
      end do
      do i=1,ndat
        read(iud,*)           x(i),y(i),ye(i)
      end do
      close(iud)
c
c perform fit:
      call fitsub(ndat,x,y,ye,nfit,a,cova,amat,chi2,lpri)
c
      write(iuo,'(/," results for the fit parameters:")')
      do i=1,nfit
        ae(i)=sqrt(cova(i,i))
        write(iuo,'(i6,".  a(i) =",g16.7,"  +/-",1g16.7)') i,a(i),ae(i)
      end do
      write(iuo,'("  chi2    of the fit:",g16.7)') chi2
c
c prepare gnuplot plot:
      call fit_gnu(iuo,iud,ndat,nfit,x,y,ye,a)
c
      stop
      end

      include '../../libs/fortran/fitsub.f'
      include '../../libs/fortran/mat_gau.f'
      include '../../libs/fortran/fit_gnu.f'
      include '../../libs/fortran/fla.f'
      include '../../libs/subs/subg_la3su2.f' ! subg.
